#include "stdafx.h"
#include "GstOpenCV.h"


CGstOpenCV::CGstOpenCV(const char *pipelineString_, const char *gstreamerPath_): CGstVideo(pipelineString_, gstreamerPath_)
{
	frame = NULL;
}


CGstOpenCV::~CGstOpenCV()
{
	//  
	release();
}

//  
void CGstOpenCV::release ()
{
	CGstVideo::release();

	if (frame)
	{
		frame->imageData = 0;
		cvReleaseImage(&frame);
	}
}

//    
IplImage *CGstOpenCV::getFrame ()
{
	if (!frame)
	{
		gint width = getWidth();
		gint height = getHeight();
		gint channels = getChannels();

		if (!width || !height || !channels)
		{
			setInfoMessage("     OpenCV  ");
			return NULL;
		}

		frame = cvCreateImageHeader(cvSize(width, height), IPL_DEPTH_8U, channels);
	}

	frame->imageData = (char*)getFrameBuffer();

	return frame;
}
